Subject: Re: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

From: "Ketan Talaulikar (ketant)" <[email-masked]>
Date: Thu, 3 Dec 2020 07:44:19 +0000

Hi Les,

Please check inline below.

From: Les Ginsberg (ginsberg) <[email-masked]>
Sent: 20 November 2020 22:59
To: Ketan Talaulikar (ketant) <ketant=[email-masked]>; Ketan Talaulikar (ketant) <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: RE: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Ketan –

We might have to “agree to disagree” here – but a few comments inline.

From: Ketan Talaulikar (ketant) <ketant=[email-masked]<mailto:ketant=[email-masked]>>
Sent: Friday, November 20, 2020 2:19 AM
To: Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>>; Ketan Talaulikar (ketant) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: RE: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Hi Les,

While I agree with you that garbage collection is hygienic it might be fraught with challenges specifically in the case of BGP-LS. We need to remember that unlike protocols like IS-IS, in BGP-LS most of the information is carried opaquely in BGP itself.

[Les:] I am amused by your use of the word “hygienic”. In this context we are not cleaning up things because they are in some way “dirty”. They are simply no longer useful.
Perhaps “recycling” is a more apt term?
[KT] Agree – bad choice of word!

There is a high potential to trip up implementations. While the option of just letting them be (even if un-used) is less harmful and certainly will not be disruptive.

[Les:] I don’t think there is a rush to reclaim, but you are advocating a “never reclaim” policy. On that we do not agree.
[KT] Let me correct myself – never say never 😊. My point was that RFC7370 points to RFC7120 for the deallocation process and that process requires renewals and is too “aggressive” IMHO in its recycling approach (Ref https://tools.ietf.org/html/rfc7120#section-3.3). That brings us back to the process overhead and pain with early-allocation that I thought we are trying to avoid for BGP-LS. Therefore, for BGP-LS, we do not need this part. The IDR WG group, at some point in the (hopefully distant) future, can publish a very short RFC to “reclaim/recycle” deprecated or un-used code points. That would be my suggestion.

Thanks,
Ketan

Coming to operators asking vendors for implementations – I would recommend that they look at the reference column in the registry to the document (and its status) where the allocation is made. That should give an appropriate indication and I can only be hopeful that operators don’t use IANA registries to put together RFPs 😉

[Les:] Good luck with that. 😊
Customers who closely follow IETF work won’t have issues. But there is a much larger population of folks who do not closely follow IETF work, but rely on the normative output to drive their RFPs. Certainly a codepoint registry is a normative output.

   Les

Thanks,
Ketan

From: Idr <[email-masked]<mailto:[email-masked]>> On Behalf Of Les Ginsberg (ginsberg)
Sent: 20 November 2020 14:31
To: Ketan Talaulikar (ketant) <ketant=[email-masked]<mailto:ketant=[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Ketan –

For me, reclaiming codepoints associated w documents which do not progress is not about minimizing assigned codepoints – it is about garbage collection.
Otherwise, when you look at the registry(s) you see a bunch of allocations for things that never gained support – but folks (especially customers) wonder whether it is important to ask vendors to support it.

  Les

From: Ketan Talaulikar (ketant) <ketant=[email-masked]<mailto:ketant=[email-masked]>>
Sent: Friday, November 20, 2020 12:42 AM
To: Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: RE: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Hi Adrian,

On top of what Les has suggested below, I would like to provide just one comment.

The point (6) in the RFC7370 text would not (IMHO) be applicable for BGP-LS where we have an abundant amount of TLV space (unlike IS-IS). I would suggest this be dropped – so once allocated stays allocated. We could add some text instead that allows the requester to deprecate some TLVs (down the line) or for the WG to do the same via the usual RFC process.

Thanks,
Ketan

From: Idr <[email-masked]<mailto:[email-masked]>> On Behalf Of Les Ginsberg (ginsberg)
Sent: 20 November 2020 11:46
To: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Adrian –

I think the text from RFC 7370 should be used.
Only thing I might add (between #4 and #5) is:

The Designated Experts must ensure that any other request for a code point does not conflict with
   work that is active or already published within the IETF.

   Les

From: Idr <[email-masked]<mailto:[email-masked]>> On Behalf Of Adrian Farrel
Sent: Thursday, November 19, 2020 9:53 PM
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Hi all,

[Replying top of thread]

This is very promising: thanks for the input so far. I’ll try not to be so bold that I take four emails as overwhelming consensus, but it looks good.

The next step would be to wordsmith the DE guidance text. Currently we have:

   In all cases of review by the Designated Expert (DE) described here,
   the DE is expected to check the clarity of purpose and use of the
   requested code points.  Additionally, the DE must verify that any
   request for one of these code points has been made available for
   review and comment within the IETF: the DE will post the request to
   the IDR Working Group mailing list (or a successor mailing list
   designated by the IESG).  If the request comes from within the IETF,
   it should be documented in an Internet-Draft.  Lastly, the DE must
   ensure that any other request for a code point does not conflict with
   work that is active or already published within the IETF.

Issues appear to be (in no particular order):

  *   Alvaro thinks using 8174 language would be appropriate
  *   Do we require an I-D for *all* requests?
  *   What level of review from the WG / mailing list do we have?

     *   How long does it last?
     *   Does the DE have to listen to the review?
     *   Does the DE have to engage with the review?
     *   How are differences of opinion handled?
     *   Is WG consensus required?
     *   How are registry conflicts handled?

  *   Given the timing, do we now just wait for rfc7752bis?
  *   Should assignments that reference an I-D also include the
version number of the I-D?

For reference, the text in RFC 7370 is:

   When new I-Ds are introduced requiring new codepoints, it is
   advantageous to be able to allocate codepoints without waiting for
   them to progress to RFC.  The reasons this is advantageous are
   described in [RFC7120].  However, the procedures in [RFC7120] for
   early allocation do not apply to registries, such as the "IS-IS TLV
   Codepoints" registry, that utilize the "Expert Review" allocation
   policy.  In such cases, what is required is that a request be made to
   the Designated Experts who MAY approve the assignments according to
   the guidance that has been established for the registry concerned.

   The following guidance applies specifically to the "IS-IS TLV
   Codepoints" registry.

   1.  Application for a codepoint allocation MAY be made to the
       Designated Experts at any time.

   2.  The Designated Experts SHOULD only consider requests that arise
       from I-Ds that have already been accepted as Working Group
       documents or that are planned for progression as AD Sponsored
       documents in the absence of a suitably chartered Working Group.

   3.  In the case of Working Group documents, the Designated Experts
       SHOULD check with the Working Group chairs that there is
       consensus within the Working Group to make the allocation at this
       time.  In the case of AD Sponsored documents, the Designated
       Experts SHOULD check with the AD for approval to make the
       allocation at this time.

   4.  The Designated Experts SHOULD then review the assignment requests
       on their technical merit.  The Designated Experts SHOULD NOT seek
       to overrule IETF consensus, but they MAY raise issues for further
       consideration before the assignments are made.

   5.  Once the Designated Experts have granted approval, IANA will
       update the registry by marking the allocated codepoints with a
       reference to the associated document as normal.

   6.  In the event that the document fails to progress to RFC, the
       Expiry and deallocation process defined in [RFC7120] MUST be
       followed for the relevant codepoints -- noting that the
       Designated Experts perform the role assigned to Working Group
       chairs.

Best,
Adrian

From: Gyan Mishra <[email-masked]<mailto:[email-masked]>>
Sent: 20 November 2020 04:03
To: Acee Lindem (acee) <acee=[email-masked]<mailto:acee=[email-masked]>>
Cc: Ketan Talaulikar (ketant) <ketant=[email-masked]<mailto:ketant=[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [Idr] Debate about IANA assignment policies for BGP-LS registries

Hi Adrian

I agree with Ketan as well on option #3.

Thanks

Gyan

On Thu, Nov 19, 2020 at 9:29 AM Acee Lindem (acee) <acee=[email-masked]<mailto:[email-masked]>> wrote:
Hi Adrian,
I agree with Ketan and would vote for #3 - I thought the last thread was just wordsmithing the DE guidance and not grounds for a document reset.
Thanks,
Acee

On 11/19/20, 8:34 AM, "Idr on behalf of Ketan Talaulikar (ketant)" <[email-masked]<mailto:[email-masked]> on behalf of ketant=[email-masked]<mailto:[email-masked]>> wrote:

    Hi Adrian,

    First, thanks for doing this.

    You've provided 3 options:
        1. Leave the assignment policies and DE instructions in place per 7752 and state that they do what we want.
        2. Leave the assignment policies in place per 7752, but change the DE instructions to give explicit advice about Internet-Drafts.
    KT> I don't believe the first two options can solve/address the main issue why we went down this path. i.e. the "permanency" point for "Specification Required" in RFC8126 and what is there today in the I-D boilerplate. That is a different battle.

        3. Change the assignment policies to be simply "Expert Review" and change the DE instructions to describe what the DE must do.
    KT> I would vote for this one. "Expert Review" is what is already there in draft-ietf-idr-bgp-ls-registries. The only change required is the text for DE guidance and for that the text in RFC7370 (i.e. the way it is done in IS-IS) looks apt to me for BGP-LS.

    If there is more tweaking that the WG requires, then let us remember that https://datatracker.ietf.org/doc/draft-ietf-idr-rfc7752bis/ is following up right behind (hopefully very soon).

    The goal of draft-ietf-idr-bgp-ls-registries was to get a "quick point fix" RFC for the allocation scheme for BGP-LS code-points. IMHO stretching it out much further just defeats its purpose.

    Thanks,
    Ketan

    -----Original Message-----
    From: Idr <[email-masked]<mailto:[email-masked]>> On Behalf Of Adrian Farrel
    Sent: 19 November 2020 13:56
    To: [email-masked]<mailto:[email-masked]>
    Cc: [email-masked]<mailto:[email-masked]>
    Subject: [Idr] Debate about IANA assignment policies for BGP-LS registries

    Hi,

    You may have noticed some recent debate about draft-ietf-idr-bgp-ls-registries on the IDR list.

    It is possible that, notwithstanding WG last call, the draft doesn't correctly capture what the working group wanted.

    Since I hold the pen for the draft and am one of the Designated Experts for the registry, I will try to set out my understanding of what we currently have, what the document says, and what questions the WG may need to address next.

    [For the avoidance of doubt: I'm just trying to serve the WG and clarify the instructions to the DEs, I don't have much of an opinion about this.]

    The registries were created by RFC 7752 and currently make assignments according to "Specification Required." RFC 8126 (which post-dated RFC 7752) defines these terms in section 4.6. "Specification Required" includes the requirement for:
    - review by a Designated Expert
    - documentation in a permanent and readily available public specification

    Debate rages about the meaning of "permanent" in this context. Does an Internet-Draft count, does it expire, or is it archived by the tools page?
    Does an individual I-D count, or does it need to be adopted first? Does IANA track the I-D version, and if not what does it mean when a new version changes the meaning of a code point?

    As Alvaro, our AD remarks, IDR is not the place to have this debate. It is probably an IETF-wide debate and anyone is welcome to take it up with IANA and the IESG.

    What we need to do is decide what we want as our policy for these registries to be, and then work out how to achieve it. We can then set the DE guidance (see section 5.1 of RFC 7752) to achieve the right results.

    It seems, from various discussions on the list, that the WG (or some of its more vocal participants) want to be able to assign code points based on I-Ds and without requiring to do early allocation (RFC 7120). There seem (to me) to be three ways to approach this:

    1. Leave the assignment policies and DE instructions in place per 7752 and state that they do what we want.
    2. Leave the assignment policies in place per 7752, but change the DE instructions to give explicit advice about Internet-Drafts.
    3. Change the assignment policies to be simply "Expert Review" and change the DE instructions to describe what the DE must do.

    The current draft seeks to implement option 3.

    I'd note that a secondary issue arises about requests for codepoints arising from outside the IETF. Suppose another SDO or a vendor wants a code point:
    Do they have to write an I-D? Does it have to gain adoption in the WG?

    The chairs have a slide on this for the meeting on Friday. I'll leave it to them to decide whether there is time in the meeting to discuss the topic, but the agenda was previously full. Perhaps a discussion on this list would be better.

    Best,
    Adrian

    _______________________________________________
    Idr mailing list
    [email-masked]<mailto:[email-masked]>
    https://www.ietf.org/mailman/listinfo/idr

    _______________________________________________
    Idr mailing list
    [email-masked]<mailto:[email-masked]>
    https://www.ietf.org/mailman/listinfo/idr

_______________________________________________
Idr mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/idr
--

[Image removed by sender.]<http://www.verizon.com/>

Gyan Mishra

Network Solutions Architect

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Thu, 3 Dec 2020 15:52:21 +0000

Ketan –

I am not wedded to a particular recycle policy – though if we adopt the RFC 7370 requirements that there be a WG document in order to qualify for early allocation it isn’t clear to me why RFC 7370 policy of reclaiming wouldn’t be reasonable.

I certainly do NOT want to have write an RFC to get unused code points recycled. That’s way too much overhead!!

Looking forward to the next step in progressing the draft.

   Les

From: Ketan Talaulikar (ketant) <[email-masked]>
Sent: Wednesday, December 02, 2020 11:44 PM
To: Les Ginsberg (ginsberg) <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: RE: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Hi Les,

From: Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>>
Sent: 20 November 2020 22:59
To: Ketan Talaulikar (ketant) <ketant=[email-masked]<mailto:ketant=[email-masked]>>; Ketan Talaulikar (ketant) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: RE: [Idr] Next steps: Debate about IANA assignment policies for BGP-LS registries

Ketan –

Hi Les,

Thanks,
Ketan

   Les

Thanks,
Ketan

Ketan –

  Les

Hi Adrian,

Thanks,
Ketan

Adrian –

   Les

Hi all,

[Replying top of thread]

     *   How long does it last?

Best,
Adrian

Hi Adrian

Thanks

Gyan

    Hi Adrian,

    Thanks,
    Ketan

    -----Original Message-----
    From: Idr <[email-masked]<mailto:[email-masked]>> On Behalf Of Adrian Farrel
    Sent: 19 November 2020 13:56
    To: [email-masked]<mailto:[email-masked]>
    Cc: [email-masked]<mailto:[email-masked]>
    Subject: [Idr] Debate about IANA assignment policies for BGP-LS registries

    Hi,

    Best,
    Adrian

Gyan Mishra

M 301 502-1347
13101 Columbia Pike
Silver Spring, MD